<template>
  <div class="three fields">
    <div
      v-for="(shedule, index) in schedules"
      :key="index"
      class="field schedule">

      <div class="flexline">
        <div class="mode setup">
          <div
            v-for="(weekDay,wIndex) in weekDays"
            :key="wIndex"
            class="item"
            :class="{
              active: weekDays[wIndex].id === index,
              disabled: weekDays[wIndex].id !== index && weekDays[wIndex].id !== false
          }">
            <span v-if="weekDays[wIndex].id !== index && weekDays[wIndex].id !== false">{{ weekDay.name }}</span>
            <span
              v-else
              @click="weekDayClick(shedule, weekDay.name, index)">{{ weekDay.name }}</span>
          </div>
        </div>
        <button
          class="button-delete"
          @click.stop.prevent="deleteItem(index)"/>
      </div>

      <div class="flexline">
        <div class="ui input range">
          <masked-input
            type="text"
            placeholder="с"
            mask="##:##"
            @input="onInput($event, 'hour', 'begin', index)"
            @blur.native="onBlur('hour', 'begin', index)"
            @mouseover.native="onMouseover"
            @mouseleave.native="onMouseleave"
            :masked="true"
            :value="shedule.hour.begin"
            :disabled="!shedule.hour.enabled"/>
        </div>
        <div class="divider">-</div>
        <div class="ui input range">
          <masked-input
            type="text"
            placeholder="до"
            mask="##:##"
            @input="onInput($event, 'hour', 'end', index)"
            @blur.native="onBlur('hour', 'end', index)"
            @mouseover.native="onMouseover"
            @mouseleave.native="onMouseleave"
            :masked="true"
            :value="shedule.hour.end"
            :disabled="!shedule.hour.enabled"/>
        </div>
        <div class="ui checkbox">
          <input
            type="checkbox"
            :name="'checkWeekDay-' + index"
            :id="'checkWeekDay-' + index"
            :checked="!shedule.hour.enabled"
            @change="changeHours(shedule)">
          <label :for="'checkWeekDay-' + index">24&nbsp;часа</label>
        </div>
      </div>

      <div class="ui checkbox">
        <input
          type="checkbox"
          :name="'checkLunch' + index"
          :id="'checkLunch' + index"
          :checked="shedule.lunch.enabled"
          @change="changeLunch(shedule)">
        <label :for="'checkLunch' + index">Есть перерыв</label>
      </div>

      <div
        v-if="shedule.lunch.enabled"
        class="flexline">
        <div class="ui input range">
          <masked-input
            type="text"
            mask="##:##"
            @input="onInput($event, 'lunch', 'begin', index)"
            @blur.native="onBlur('lunch', 'begin', index)"
            @mouseover.native="onMouseover"
            @mouseleave.native="onMouseleave"
            :masked="true"
            :value="shedule.lunch.begin"
            placeholder="с"/>
        </div>
        <div class="divider">-</div>
        <div class="ui input range">
          <masked-input
            type="text"
            mask="##:##"
            @input="onInput($event, 'lunch', 'end', index)"
            @blur.native="onBlur('lunch', 'end', index)"
            @mouseover.native="onMouseover"
            @mouseleave.native="onMouseleave"
            :masked="true"
            :value="shedule.lunch.end"
            placeholder="до"/>
        </div>
      </div>
    </div>

    <button
      v-if="schedules.length < 3 && weekDays.filter(day => day.id === false).length || schedules.length === 0"
      @click="addItem"
      class="ui button transparent small add-schedule">
      + Добавить расписание
    </button>
  </div>
</template>

<script>
import { TheMask } from 'vue-the-mask';

export default {
  name: 'SetSchedule',
  components: {
    'masked-input': TheMask,
  },
  model: {
    prop: 'schedules',
    event: 'change',
  },
  props: {
    schedules: {
      type: Array,
      required: true,
    },
    initialSchedules: {
      type: Array,
      default: () => [],
    },
  },
  data() {
    return {
      reservePlaceholder: {
        curr: '',
        temp: '__:__',
      },
      weekDays: [
        { name: 'пн', id: false },
        { name: 'вт', id: false },
        { name: 'ср', id: false },
        { name: 'чт', id: false },
        { name: 'пт', id: false },
        { name: 'сб', id: false },
        { name: 'вс', id: false },
      ],
    };
  },
  mounted() {
    if (this.initialSchedules.length) {
      this.$emit('change', this.convertSchedulesToData());
    }
  },
  methods: {
    convertSchedulesToData() {
      const result = [];
      const weekDaysNames = this.weekDays.map(day => day.name);
      let currentHourBegin = 0;
      let currentHourEnd = 0;
      let currentLunchBegin = 0;
      let currentLunchEnd = 0;
      let resultCurrentIndex = 0;

      const resPush = (weekDayName, dayBegin, dayEnd, lunchBegin, lunchEnd) => {
        result.push({
          days: [weekDayName],
          hour: { enabled: dayBegin && dayEnd, begin: dayBegin, end: dayEnd },
          lunch: { enabled: lunchBegin && lunchEnd, begin: lunchBegin, end: lunchEnd },
        });
      };

      if (this.initialSchedules.length) {
        this.initialSchedules.forEach((day) => {
          // Ранее дни недели отправлялись с 0 до 6, сейчас с 1 до 7
          const dayName = this.initialSchedules[0].dayNumber - 1 >= 0
            ? weekDaysNames[day.dayNumber - 1]
            : weekDaysNames[day.dayNumber];

          const dayIndex = weekDaysNames.indexOf(dayName);
          if (currentHourBegin === 0) currentHourBegin = day.openingTime;
          if (currentHourEnd === 0) currentHourEnd = day.closingTime;
          if (currentLunchBegin === 0) currentLunchBegin = day.dinnerBeginTime;
          if (currentLunchEnd === 0) currentLunchEnd = day.dinnerEndTime;

          if (currentHourBegin === day.openingTime
          && currentHourEnd === day.closingTime
          && currentLunchBegin === day.dinnerBeginTime
          && currentLunchEnd === day.dinnerEndTime) {
            if (result.length) {
              result[resultCurrentIndex].days.push(dayName);
              this.weekDays[dayIndex].id = resultCurrentIndex;
            } else {
              resPush(dayName, day.openingTime, day.closingTime, day.dinnerBeginTime, day.dinnerEndTime);
              this.weekDays[dayIndex].id = result.length - 1;
            }
          } else {
            let findIndex = false;
            result.forEach((schedule, index) => {
              if (day.openingTime === schedule.hour.begin
              && day.closingTime === schedule.hour.end
              && day.dinnerBeginTime === schedule.lunch.begin
              && day.dinnerEndTime === schedule.lunch.end) {
                findIndex = index;
              }
            });

            if (findIndex === false) {
              resultCurrentIndex += 1;
              currentHourBegin = day.openingTime;
              currentHourEnd = day.closingTime;
              currentLunchBegin = day.closingTime;
              currentLunchEnd = day.dinnerEndTime;

              if (!result[resultCurrentIndex]) {
                resPush(dayName, day.openingTime, day.closingTime, day.dinnerBeginTime, day.dinnerEndTime);
                this.weekDays[dayIndex].id = result.length - 1;
              } else {
                result[resultCurrentIndex].days.push(dayName);
                this.weekDays[dayIndex].id = resultCurrentIndex;
              }
            } else {
              this.weekDays[dayIndex].id = findIndex;
              result[findIndex].days.push(dayName);
            }
          }
        });
      }
      return result;
    },
    onMouseover(evt) {
      if (!evt.target.value) {
        this.reservePlaceholder.curr = evt.target.placeholder;
        evt.target.placeholder = this.reservePlaceholder.temp;
      }
    },
    onMouseleave(evt) {
      if (this.reservePlaceholder.curr) {
        evt.target.placeholder = this.reservePlaceholder.curr;
        this.reservePlaceholder.curr = '';
      }
    },
    onInput(data, type, time, index) {
      const schedules = this.schedules;
      schedules[index][type][time] = data;
      this.$emit('change', schedules);
    },
    onBlur(type, time, index) {
      const schedules = this.schedules;
      if (schedules[index][type][time]) {
        // Проверка поля времени аналогично с backend
        const timeRegex = /^([01]\d|2[0-3]):?([0-5]\d)$/;
        const isValidTime = timeRegex.test(schedules[index][type][time]);

        schedules[index][type][time] = isValidTime ? schedules[index][type][time] : '';
        this.$emit('change', schedules);
      }
    },
    addItem() {
      const newItem = this.schedules;
      newItem.push({
        days: [],
        hour: { enabled: false, begin: null, end: null },
        lunch: { enabled: false, begin: null, end: null },
      });
      this.$emit('change', newItem);
    },
    deleteItem(index) {
      const newItem = this.schedules;
      newItem.splice(index, 1);
      this.weekDays = this.weekDays.map(day => ({ name: day.name, id: false }));
      newItem.forEach((schedule, sindex) => {
        schedule.days.forEach((weekDay) => {
          const dayIndex = this.weekDays.findIndex(day => day.name === weekDay);
          this.weekDays[dayIndex].id = sindex;
        });
      });
      this.$emit('change', newItem);
    },
    weekDayClick(schedule, weekDay, index) {
      const key = schedule.days.indexOf(weekDay);
      const dayIndex = this.weekDays.findIndex(day => day.name === weekDay);
      if (key !== -1) {
        schedule.days.splice(key, 1);
        this.weekDays[dayIndex].id = false;
      } else {
        schedule.days.push(weekDay);
        this.weekDays[dayIndex].id = index;
      }
      this.$emit('change', this.schedules);
      this.$emit('input', this.schedules);
    },
    changeHours(schedule) {
      schedule.hour.enabled = !schedule.hour.enabled;
    },
    changeLunch(schedule) {
      schedule.lunch.enabled = !schedule.lunch.enabled;
    },
  },
};
</script>

<style scoped lang="postcss">
  .button-delete {
    flex: 1 0 2rem;
    display: block;
    width: 2rem;
    height: 2rem;
    margin-left: 0.875rem;
    outline: none;
    border: none;
    box-shadow: none;
    border-radius: 0.25rem;
    background-color: #728896;
    background-position: center;
    background-repeat: no-repeat;
    background-size: 0.8125rem auto;
    background-image: url('data:image/svg+xml;base64,PD94bWwgdmVyc2lvbj0iMS4wIiBlbmNvZGluZz0idXRmLTgiPz4KPHN2ZyBjbGFzcz0ic3ZnLWZpbGwiIGZpbGw9IiNmZmZmZmYiIHhtbG5zPSJodHRwOi8vd3d3LnczLm9yZy8yMDAwL3N2ZyIgeG1sbnM6eGxpbms9Imh0dHA6Ly93d3cudzMub3JnLzE5OTkveGxpbmsiIHg9IjBweCIgeT0iMHB4IgoJIHZpZXdCb3g9IjAgMCAxMiAxNCIgc3R5bGU9ImVuYWJsZS1iYWNrZ3JvdW5kOm5ldyAwIDAgMTIgMTQ7IiB4bWw6c3BhY2U9InByZXNlcnZlIj4KCjxyZWN0IHg9IjciIHk9IjUiIHdpZHRoPSIxIiBoZWlnaHQ9IjYiLz4KPHJlY3QgeD0iNCIgeT0iNSIgd2lkdGg9IjEiIGhlaWdodD0iNiIvPgo8cGF0aCBkPSJNMTIsMkg4LjVWMS41QzguNiwwLjcsOCwwLjEsNy4yLDBINC44QzQsMC4xLDMuNCwwLjcsMy41LDEuNVYySDB2MWgxdjguNUMxLDEyLjksMi4xLDE0LDMuNSwxNAoJaDVjMS40LDAsMi41LTEuMSwyLjUtMi41VjNoMVYyeiBNNC41LDEuNUM0LjUsMS4yLDQuNywxLDQuOCwxaDIuNGMwLjEsMCwwLjMsMC4yLDAuMywwLjVWMmgtM1YxLjV6IE0xMCwxMS41YzAsMC44LTAuNywxLjUtMS41LDEuNQoJaC01QzIuNywxMywyLDEyLjMsMiwxMS41VjNoOFYxMS41eiIvPgo8L3N2Zz4K');
    cursor: pointer;
    transition: 0.1s ease background-color;
    &:hover {
      background-color: #345A81;
    }
  }

  .button.add-schedule {
    display: block;
    margin: 0 0 auto 2rem;
  }

  .fields {
    > .button.add-schedule:first-child {
      margin-left: 0.5rem;
    }
    .field.schedule + .field.schedule {
      padding-left: 1rem;
    }
  }

  .flexline {
    display: flex;
    flex-flow: row nowrap;
    justify-content: flex-start;
    align-items: center;
    margin-bottom: 0.875rem;
    .ui.input.range {
      width: calc((100% - 1rem - 5.75rem)/2) !important;
    }
    .ui.checkbox label {
      margin: 0 0 0 1rem;
    }
    .divider {
      display: block;
      font-size: 1rem;
      padding: 0 0.5rem;
    }
  }

  .mode.setup {
    display: flex;
    flex-flow: row nowrap;
    justify-content: space-between;
    align-items: stretch;
    width: 16.5rem;
    height: 2rem;
    border-radius: 0.25rem;
    border: 1px solid #9badb9;
    overflow: hidden;
    > .item {
      display: inline-flex;
      justify-content: center;
      align-items: center;
      width: 100%;
      background-color: #ffffff;
      border-right: 1px solid #9badb9;
      font-size: 13px;
      font-weight: 500;
      color: #272727;
      cursor: pointer;
      transition: 0.1s ease background-color, color;
      span {
        width: 100%;
        height: 100%;
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: center;
      }
      &:last-child {
        border-right: none;
      }
      &:hover, &.active {
        background-color: #4272a4;
        color: #fff;
      }
      &.disabled, &.disabled:hover {
        color: #95989a !important;
        background-color: #fff !important;
        cursor: default !important;
      }
    }
  }

</style>
